from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n
import time
import os

class LTVFontSelector(Sensor):

	def __init__(self, font_default = "Font|Sans 8|black|0"):
		global _; _ = i18n.Translator("font-selector-sensor")
		Sensor.__init__(self)
		
		titles = []
		i = 0
		
		for font in font_default.split('||') :
			entry = font.split('|')
			titles = titles + [ entry[ 0 ] ]
			self._set_config_type("font%i" % i, TYPE_STRING, entry[1])
			self._set_config_type("color%i" % i, TYPE_STRING, entry[2])
			self._set_config_type("offset%i" % i, TYPE_INT, int(entry[3]))
			i = i + 1

		self.__entries = titles
		self._add_timer( 1000, self.__on_tick )
	def __on_tick(self):
		data = self._new_output()
		i = 0
		while i < len( self.__entries ) :
			data.set( "font%i" % i, self._get_config("font%i" % i).encode("UTF-8"))
			data.set( "color%i" % i, self._get_config("color%i" % i).encode("UTF-8"))
			data.set( "offset%i" % i, self._get_config("offset%i" % i))
			i = i + 1
		self._send_output(data)
		return 1
	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Fonts"))

		i = 0
		for entry in self.__entries:
			configurator.add_title( entry )
			if self._get_config("font%i" % i) != "NULL" :
				configurator.add_font_selector(_("Font:"), "font%i" % i, _("Set the text color for ") + "\"" + entry + "\"")
			if self._get_config("color%i" % i) != "NULL" :
				configurator.add_color_selector(_("Color:"), "color%i" % i, _("Set the text color for ") + "\"" + entry + "\"")
			if self._get_config("offset%i" % i) != 999 :
				configurator.add_spin(_("Vertical position:"), "offset%i" % i, _("Vertical position of text"), -100, 100)

			i = i + 1
			                           
		return configurator

def new_sensor(args): return apply(LTVFontSelector, args)
